searchNodes=[{"doc":"This will render a PromEx dashboard either to STDOUT or to a file depending on the CLI arguments that are provided. The following CLI flags are supported: -d, --dashboard The name of the dashboard that you would like to export from PromEx. For example, if you would like to export the Ecto dashboard, provide the value `ecto.json`. -m, --module The PromEx module which will be used to render the dashboards. This is needed to fetch any relevant assigns from the `c:PromEx.dashboard_assigns/0` callback -s, --stdout A boolean flag denoting that the rendered dashboard should be output to STDOUT. -f, --file_path If you would like the write the generated JSON dashboard definition to a file, you can provide a relative file path in the project's `priv` directory. -a, --assign Any additional assigns you would like to pass to the dashboard for rendering. You are able to pass multiple assigns by passing multiple --assign arguments. For example: `--assign some=thing --assign another=thing`.","ref":"Mix.Tasks.PromEx.Dashboard.Export.html","title":"Mix.Tasks.PromEx.Dashboard.Export","type":"task"},{"doc":"This will lint Grafana dashboards to ensure that PromEx dashboards meeting certain requirements.","ref":"Mix.Tasks.PromEx.Dashboard.Lint.html","title":"Mix.Tasks.PromEx.Dashboard.Lint","type":"task"},{"doc":"This mix task will publish dashboards to Grafana for a PromEx module. It is recommended that you use the functionality that is part of the PromEx supervision tree in order to upload dashboards as opposed to this, given that mix may not always be available (like in a mix release). This is more so a convenience for testing and validating dashboards without starting the whole application. The following CLI flags are supported: -m, --module The PromEx module which will be used to render the dashboards. This is needed to fetch any relevant assigns from the `c:PromEx.dashboard_assigns/0` callback and to get the Grafana configuration from app config. -t, --timeout The timeout value defines how long the mix task will wait while uploading dashboards.","ref":"Mix.Tasks.PromEx.Dashboard.Publish.html","title":"Mix.Tasks.PromEx.Dashboard.Publish","type":"task"},{"doc":"This Mix Task generates a PromEx config module in your project. This config file acts as a starting point with instructions on how to set up PromEx in your application, some default PromEx metrics plugins, and their accompanying dashboards. The following CLI flags are supported: -d, --datasource The datasource that the dashboards will be reading from to populate their time series data. This `datasource` value should align with what is configured in Grafana from the Prometheus instance's `datasource_id`. -o, --otp_app The OTP application that PromEx is being installed in. This should be provided as the snake case atom (minus the leading colon). For example, if the `:app` value in your `mix.exs` file is `:my_cool_app`, this argument should be provided as `my_cool_app`. By default PromEx will read your `mix.exs` file to determine the OTP application value so this is an OPTIONAL argument.","ref":"Mix.Tasks.PromEx.Gen.Config.html","title":"Mix.Tasks.PromEx.Gen.Config","type":"task"},{"doc":"PromEx is a plugin based library which can be used to capture telemetry events and report them out for consumption by Prometheus. The main purpose of this particular library is to provide the behaviour that all PromEx plugins leverage so that a consistent interface can be achieved and so that leveraging multiple plugins is effortless from the user's point of view. To use PromEx you need to define a module that uses the PromEx library. This module will also need to have some application config set for it similarly to how Ecto does. For example, for a PromEx module defined like so: defmodule MyApp.PromEx do use PromEx , otp_app : :web_app ... end You would have an application configuration set like so: config :my_app , MyApp.PromEx , manual_metrics_start_delay : :no_delay , drop_metrics_groups : [ ] , grafana : [ host : System . get_env ( &quot;GRAFANA_HOST&quot; , &quot;http://grafana:3000&quot; ) , auth_token : System . get_env ( &quot;GRAFANA_TOKEN&quot; , &quot;&quot; ) , upload_dashboards_on_start : true , folder_name : &quot;My App Dashboards&quot; , annotate_app_lifecycle : true ] The options that you can pass to PromEx macro are outlined in the following section. In order to tell PromEx what plugins you would like to use and what dashboards you would like PromEx to upload for you, implement the plugins/0 and dashboards/0 callbacks respectively. The dashboard_assigns/0 callback will be used when your EEx template Grafana dashboards are rendered so that the dashboards that are created for your application coincide with the PromEx configuration for the application. If your dashboards are not EEx templates, then the dashboard assigns are not passed through. Each plugin also has an accompanying Grafana dashboard that you can leverage to plot all of the plugin captured data. In order to expose captured metrics, you can leverage the PromEx provided Plug PromEx.Plug . See the PromEx.Plug documentation modules for specifics on how to use it. Options :otp_app - This is a REQUIRED field and is used by PromEx to fetch the application configuration values for the various PromEx capture modules. Make sure that this value matches the :app value in project/0 from your mix.exs file. If you use the PromEx mix prom_ex.create mix task this will be done automatically for you. PromEx Plugins All metrics collection will be delegated to plugins which can be found here: Foundational metrics: [X] PromEx.Plugins.Application Application related informational metrics [X] PromEx.Plugins.Beam BEAM virtual machine metrics [ ] Operating System ( http://erlang.org/doc/man/os_mon_app.html ) Library metrics: [X] Ecto ( https://hexdocs.pm/ecto/Ecto.Repo.html#module-telemetry-events ) [X] Oban ( https://hexdocs.pm/oban/Oban.Telemetry.html ) [X] Phoenix ( https://hexdocs.pm/phoenix/Phoenix.Logger.html ) [X] Phoenix LiveView ( https://hexdocs.pm/phoenix_live_view/telemetry.html ) [X] Absinthe ( https://hexdocs.pm/absinthe/1.5.3/telemetry.html ) [X] PlugCowboy ( https://hexdocs.pm/plug_cowboy/2.4.0/Plug.Cowboy.html#module-instrumentation ) [X] PlugRouter ( https://hexdocs.pm/plug/1.12.1/Plug.Router.html#module-telemetry ) [X] Broadway ( https://hexdocs.pm/broadway/Broadway.html#module-telemetry ) Backlog Elixir library metrics: [ ] Finch ( https://hexdocs.pm/finch/Finch.Telemetry.html#content ) [ ] Swoosh ( https://hexdocs.pm/swoosh/1.5.0/Swoosh.html#module-telemetry ) [ ] ChromicPDF ( https://hexdocs.pm/chromic_pdf/ChromicPDF.html#module-telemetry-support ) [ ] Dataloader ( https://hexdocs.pm/dataloader/telemetry.html ) [ ] GenRMQ ( https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Publisher.Telemetry.html and https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Consumer.Telemetry.html ) [ ] Plug ( https://hexdocs.pm/plug/Plug.Telemetry.html ) [ ] Redix ( https://hexdocs.pm/redix/Redix.Telemetry.html ) [ ] Tesla ( https://hexdocs.pm/tesla/Tesla.Middleware.Telemetry.html ) [ ] Memcachex ( https://hexdocs.pm/memcachex/0.5.0/Memcache.html#module-telemetry ) [ ] Nebulex ( https://hexdocs.pm/nebulex/2.0.0-rc.0/telemetry.html ) [ ] Horde ( https://github.com/derekkraan/horde/blob/master/lib/horde/supervisor_telemetry_poller.ex ) [ ] Cachex (Need to open up PR) [ ] Quantum ( https://hexdocs.pm/quantum/3.3.0/telemetry.html#content ) Database cron based metrics: [ ] Postgres ( https://github.com/pawurb/ecto_psql_extras for inspiration) [ ] Mnesia ( https://github.com/deadtrickster/prometheus.erl/blob/master/src/collectors/mnesia/prometheus_mnesia_collector.erl for inspiration) [ ] MySQL ( https://github.com/prometheus/mysqld_exporter for inspiration) [ ] Redis ( https://github.com/oliver006/redis_exporter for inspiration) [ ] MongoDB ( https://github.com/percona/mongodb_exporter for inspiration)","ref":"PromEx.html","title":"PromEx","type":"behaviour"},{"doc":"","ref":"PromEx.html#c:dashboard_assigns/0","title":"PromEx.dashboard_assigns/0","type":"callback"},{"doc":"","ref":"PromEx.html#c:dashboards/0","title":"PromEx.dashboards/0","type":"callback"},{"doc":"A simple pass-through to fetch all of the currently configured metrics. This is primarily used by the exporter plug to fetch all of the metrics so that they can be scraped.","ref":"PromEx.html#get_metrics/1","title":"PromEx.get_metrics/1","type":"function"},{"doc":"","ref":"PromEx.html#c:init_opts/0","title":"PromEx.init_opts/0","type":"callback"},{"doc":"","ref":"PromEx.html#c:plugins/0","title":"PromEx.plugins/0","type":"callback"},{"doc":"","ref":"PromEx.html#t:dashboard_definition/0","title":"PromEx.dashboard_definition/0","type":"type"},{"doc":"","ref":"PromEx.html#t:measurements_mfa/0","title":"PromEx.measurements_mfa/0","type":"type"},{"doc":"","ref":"PromEx.html#t:plugin_definition/0","title":"PromEx.plugin_definition/0","type":"type"},{"doc":"","ref":"PromEx.html#t:telemetry_metrics/0","title":"PromEx.telemetry_metrics/0","type":"type"},{"doc":"This module provides functions to generate histogram bucket ranges. The lists of buckets that can be generated are either linear or exponential.","ref":"PromEx.BucketGenerator.html","title":"PromEx.BucketGenerator","type":"module"},{"doc":"Create an exponential set of buckets based on the provided parameters. Examples iex&gt; PromEx.BucketGenerator . exponential! ( 1 , 4 , 10 ) [ 1 , 4 , 16 , 64 , 256 , 1024 , 4096 , 16384 , 65536 , 262144 ] iex&gt; PromEx.BucketGenerator . exponential! ( 1 , 2 , 10 ) [ 1 , 2 , 4 , 8 , 16 , 32 , 64 , 128 , 256 , 512 ]","ref":"PromEx.BucketGenerator.html#exponential!/3","title":"PromEx.BucketGenerator.exponential!/3","type":"function"},{"doc":"Create a linear set of buckets based on the provided parameters. Examples iex&gt; PromEx.BucketGenerator . linear! ( 10 , 10 , 10 ) [ 10 , 20 , 30 , 40 , 50 , 60 , 70 , 80 , 90 , 100 ] iex&gt; PromEx.BucketGenerator . linear! ( 0 , 250 , 11 ) [ 0 , 250 , 500 , 750 , 1000 , 1250 , 1500 , 1750 , 2000 , 2250 , 2500 ]","ref":"PromEx.BucketGenerator.html#linear!/3","title":"PromEx.BucketGenerator.linear!/3","type":"function"},{"doc":"This module defines a struct that contains all of the fields necessary to configure an instance of PromEx. While this module does not directly access your Application config, PromEx will call the PromEx.Config.build/1 function directly with the contents of Application.get_env(:your_otp_app, YourPromEx.Module) . As such, this is an appropriate place to talk about how you go about configuring PromEx via your Application config. By default, you can run PromEx without any additional configuration and PromEx will fall back on some sane defaults. Specifically, if you were to not add any configuration to your config.exs, dev.exs, prod.exs, etc files it would be the same as setting the following config: config :web_app , WebApp.PromEx , disabled : false , manual_metrics_start_delay : :no_delay , drop_metrics_groups : [ ] , grafana : :disabled , metrics_server : :disabled In this configuration, the Grafana dashboards are not uploaded on application start, and a standalone HTTP metrics server is not started. In addition, the PromEx.ManualMetricsManager is started without any time delay, and all metrics groups from all the plugins are registered and set up. If you would like to set up PromEx to communicate with Grafana, your config would look something like: config :web_app , WebApp.PromEx , grafana : [ host : &quot;http://localhost:3000&quot; , username : &quot;&lt;YOUR_USERNAME&gt;&quot; , # Or authenticate via Basic Auth password : &quot;&lt;YOUR_PASSWORD&gt;&quot; auth_token : &quot;&lt;YOUR_AUTH_TOKEN_HERE&gt;&quot; , # Or authenticate via API Token upload_dashboards_on_start : true # This is an optional setting and will default to `true` ] If you would like PromEx to start a standalone HTTP server to serve your aggregated metrics, you can leverage the :metrics_server config: config :web_app , WebApp.PromEx , metrics_server : [ port : 4021 , path : &quot;/metrics&quot; , # This is an optional setting and will default to `&quot;/metrics&quot;` protocol : :http , # This is an optional setting and will default to `:http` pool_size : 5 , # This is an optional setting and will default to `5` cowboy_opts : [ ] , # This is an optional setting and will default to `[]` auth_strategy : :none # This is an optional and will default to `:none` ] If you would like the metrics server to be protected behind some sort of authentication, you can configure your :metrics_server like so: config :web_app , WebApp.PromEx , metrics_server : [ port : 4021 , auth_strategy : :bearer , auth_token : &quot;VGhpcyBpcyBzdXBlciBzZWNyZXQuLi5kb24ndCBkZWNvZGUgbWU=&quot; ] Option Details :disabled - This option will diable the PromEx supervision tree entirely and will not start any metris collectors. This is primarily used for disabling PromEx during testing. Default value: false :manual_metrics_start_delay - Manual metrics are gathered once on start up and then only when you call PromEx.ManualMetricsManager.refresh_metrics/1 . Sometimes, you may have metrics that require your entire supervision tree to be started in order to fetch accurate data. This option will allow you to delays the initial metrics capture of the ManualMetricsManager by a certain number of milliseconds or the :no_delay atom if you want the metrics to be captured as soon as the ManualMetricsManager starts up. Default value: :no_delay :drop_metrics_groups - A list of all the metrics groups that you are not interested in tracking. For example, if your application does not leverage Phoenix channels at all but you still would like to use the PromEx.Plugins.Phoenix plugin, you can pass [:phoenix_channel_event_metrics] as the value to :drop_metrics_groups and that set of metrics will not be captured. Default value: [] :grafana - This key contains the configuration information for connecting to Grafana. Its configuration options are: :host - The host address of your Grafana instance. In order for PromEx to communicate with Grafana this value should be in the format protocol://host:port like http://localhost:3000 for example. :username - The username that was created in Grafana so that PromEx can upload dashboards via the API. :password - The password that was created in Grafana so that PromEx can upload dashboards via the API. :auth_token - The auth token that was created in Grafana so that PromEx can upload dashboards via the API. :upload_dashboards_on_start - Using the config values that you set in your application config ( config.exs , dev.exs , prod.exs , etc) PromEx will attempt to upload your Dashboards to Grafana using Grafana's HTTP API. :folder_name - The name of the folder that PromEx will put all of the project dashboards in. PromEx will automatically generate a unique ID for the folder based on the project's otp_app value so that it can access the correct folder in Grafana. This also makes sure that different Elixir projects running in the same cluster and publishing dashboards to Grafana do not collide with one another. If no name is provided, then the dashboards will all be uploaded to the default Grafana folder. :annotate_app_lifecycle - By enabling this setting, PromEx will leverage the Grafana API to annotate when the application was started, and when it was shut down. By default this is disabled but if you do enable it, no action is required from you in order to display these events on the dashboards. The annotations will automatically contain the necessary tags to only display on the PromEx dashboards. The annotation will include information including: Hostname OTP app name App version Git SHA of the last commit (if the GIT_SHA environment variable is present) Git author of the last commit (if the GIT_AUTHOR environment variable is present) :metrics_server - This key contains the configuration information needed to run a standalone HTTP server powered by Cowboy. This server provides a lightweight solution to serving up PromEx metrics. Its configuration options are: :port - The port that the Cowboy HTTP server should run on. :path - The path that the metrics should be accessible at. :protocol - The protocol that the metrics should be accessible over ( :http or :https ). :pool_size - How many Cowboy processes should be in the pool to handle metrics related requests. :auth_strategy - What authentication strategy should be used to authorize requests to your metrics. The Supported strategies are :none , :bearer , and :basic . Depending on what strategy is selected, you will need to also add additional config values. For :none (which is the default), no additional information needs to be provided. When using a :bearer strategy, you'll need to provide a :auth_token config value. When using :basic strategy you'll need to provide :auth_user and :auth_password values. :auth_token - When using a :bearer authentication strategy, this field is required to validate the incoming request against a valid auth token. :auth_user - When using a :basic authentication strategy, this field is required to validate the incoming request against a valid user. :auth_password - When using a :bearer authentication strategy, this field is required to validate the incoming request against a valid password. :cowboy_opts - A keyword list of any additional options that should be passed to Plug.Cowboy (see docs for more information https://hexdocs.pm/plug_cowboy/Plug.Cowboy.html). The :port and :transport_options options are handled by PromEx via the aforementioned config settings and so adding them again here has no effect.","ref":"PromEx.Config.html","title":"PromEx.Config","type":"module"},{"doc":"Create a struct that encapsulates all of the configuration needed to start a PromEx supervisor instance as well as all of the worker processes.","ref":"PromEx.Config.html#build/1","title":"PromEx.Config.build/1","type":"function"},{"doc":"manual_metrics_start_delay : How the ManualMetricsManager worker process should be started (instantly or with a millisecond delay). drop_metrics_groups : A list of metrics groups that should be omitted from the metrics collection process. grafana_config : A map containing all the relevant settings to connect to Grafana. metrics_server_config : A map containing all the relevant settings to start a standalone HTTP Cowboy server for metrics.","ref":"PromEx.Config.html#t:t/0","title":"PromEx.Config.t/0","type":"type"},{"doc":"This module is used to read dashboard definitions, render EEx dashboards, and ensure that requested files actually exist","ref":"PromEx.DashboardRenderer.html","title":"PromEx.DashboardRenderer","type":"module"},{"doc":"Read the contents of a dashboard file entry. If an EEx version of the file exists, read that, else fallback to the provided file name. For example, if the requested dashboard file is ecto.json , if ecto.json.eex exists, then that will be returned. This is more so for convenience so that you don't need to write out .eex everywhere given that all PromEx 1st party dashboards are EEx templates.","ref":"PromEx.DashboardRenderer.html#build/3","title":"PromEx.DashboardRenderer.build/3","type":"function"},{"doc":"This function will decode the JSON dashboard using Jason . If any errors occur during the decoding process, the struct will be marked as having invalid JSON.","ref":"PromEx.DashboardRenderer.html#decode_dashboard/1","title":"PromEx.DashboardRenderer.decode_dashboard/1","type":"function"},{"doc":"This function will merge in the provided assigns to the struct's assigns. These assigns will then be used during the render_dashboard/1 call to render any EEx template statements.","ref":"PromEx.DashboardRenderer.html#merge_assigns/2","title":"PromEx.DashboardRenderer.merge_assigns/2","type":"function"},{"doc":"Renders the dashboard. If it is an EEx file then the PromEx module assigns are passed. Else if it is a raw json file then it is passed through untouched.","ref":"PromEx.DashboardRenderer.html#render_dashboard/2","title":"PromEx.DashboardRenderer.render_dashboard/2","type":"function"},{"doc":"","ref":"PromEx.DashboardRenderer.html#t:t/0","title":"PromEx.DashboardRenderer.t/0","type":"type"},{"doc":"This GenServer is responsible for uploading the configured PromEx module dashboards to Grafana. This is a transient process and will terminate after the dashboards have been successfully uploaded. It requires the name of the PromEx module as an option so that it can look into the application config for the appropriate Grafana settings. For example, if the name of the PromEx module is WebApp.PromEx , then your config should provide the following settings: config :web_app , WebApp.PromEx , grafana_host : &quot;&lt;YOUR HOST ADDRESS&gt;&quot; , grafana_auth_token : &quot;&lt;YOUR GRAFANA AUTH TOKEN&gt;&quot;","ref":"PromEx.DashboardUploader.html","title":"PromEx.DashboardUploader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PromEx.DashboardUploader.html#child_spec/1","title":"PromEx.DashboardUploader.child_spec/1","type":"function"},{"doc":"Used to start the DashboardUploader process","ref":"PromEx.DashboardUploader.html#start_link/1","title":"PromEx.DashboardUploader.start_link/1","type":"function"},{"doc":"This is a convenience module used for debugging and introspecting telemetry events. Primarily used to ease the development of PromEx itself.","ref":"PromEx.Debug.html","title":"PromEx.Debug","type":"module"},{"doc":"Use this function to attach a debugger handler to a certain telemetry event.","ref":"PromEx.Debug.html#attach_debugger/1","title":"PromEx.Debug.attach_debugger/1","type":"function"},{"doc":"This module is used to regularly flush ETS of any buffered distribution type metrics (see https://github.com/beam-telemetry/telemetry_metrics_prometheus_core/blob/main/lib/core.ex#L25-L28 ) for more information. At the moment the flush interval is not configurable but that could change in the future.","ref":"PromEx.ETSCronFlusher.html","title":"PromEx.ETSCronFlusher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PromEx.ETSCronFlusher.html#child_spec/1","title":"PromEx.ETSCronFlusher.child_spec/1","type":"function"},{"doc":"This function will cancel the existing cron timer and schedule a new new. The reason for this being that if metrics scrapes occur regularly, there is no need to flush via the cron job. Cron ETS flushes should only occur if the metrics endpoint for whatever reason fails to be scraped so that ETS is not leaking memory.","ref":"PromEx.ETSCronFlusher.html#defer_ets_flush/1","title":"PromEx.ETSCronFlusher.defer_ets_flush/1","type":"function"},{"doc":"Used to start the PromEx.ETSCronFlusher process.","ref":"PromEx.ETSCronFlusher.html#start_link/1","title":"PromEx.ETSCronFlusher.start_link/1","type":"function"},{"doc":"This module is used by the Mix tasks that are available in PromEx to update dashboards in Grafana and also by the PromEx.DashboardUpdater to update dashboards automatically on application initialization. Dashboard models: https://grafana.com/docs/grafana/latest/dashboards/json-model/","ref":"PromEx.GrafanaClient.html","title":"PromEx.GrafanaClient","type":"module"},{"doc":"Used to create annotations on dashboard panels","ref":"PromEx.GrafanaClient.html#create_annotation/3","title":"PromEx.GrafanaClient.create_annotation/3","type":"function"},{"doc":"Used to create a new folder in Grafana","ref":"PromEx.GrafanaClient.html#create_folder/3","title":"PromEx.GrafanaClient.create_folder/3","type":"function"},{"doc":"Get all of the folder that exist in Grafana","ref":"PromEx.GrafanaClient.html#get_all_folders/1","title":"PromEx.GrafanaClient.get_all_folders/1","type":"function"},{"doc":"Used to get the dashboard definition currently in Grafana for the provided dashboard file. If the ID does not exist in Grafana an error tuple will be returned.","ref":"PromEx.GrafanaClient.html#get_dashboard/2","title":"PromEx.GrafanaClient.get_dashboard/2","type":"function"},{"doc":"Used to fetch the details regarding a particular folder on Grafana","ref":"PromEx.GrafanaClient.html#get_folder/2","title":"PromEx.GrafanaClient.get_folder/2","type":"function"},{"doc":"Update an existing folder in Grafana","ref":"PromEx.GrafanaClient.html#update_folder/4","title":"PromEx.GrafanaClient.update_folder/4","type":"function"},{"doc":"Used to create a new dashboard or update an existing dashboard.","ref":"PromEx.GrafanaClient.html#upload_dashboard/3","title":"PromEx.GrafanaClient.upload_dashboard/3","type":"function"},{"doc":"This struct encapsulates all of the data necessary to connect to a Grafana instance.","ref":"PromEx.GrafanaClient.Connection.html","title":"PromEx.GrafanaClient.Connection","type":"module"},{"doc":"Build a connection struct for connecting to Grafana.","ref":"PromEx.GrafanaClient.Connection.html#build/2","title":"PromEx.GrafanaClient.Connection.build/2","type":"function"},{"doc":"","ref":"PromEx.GrafanaClient.Connection.html#t:t/0","title":"PromEx.GrafanaClient.Connection.t/0","type":"type"},{"doc":"This module is used to validate Grafana dashboard to ensure that they adhere to certain style and structure requirements.","ref":"PromEx.GrafanaClient.DashboardChecker.html","title":"PromEx.GrafanaClient.DashboardChecker","type":"module"},{"doc":"This GenServer is responsible to keeping track of the life cycle of the application and sending annotation requests to Grafana when the application starts and when it terminates. It will include things in the message like: Hostname OTP app name App version Git SHA of the last commit (if the GIT_SHA environment variable is present) Git author of the last commit (if the GIT_AUTHOR environment variable is present)","ref":"PromEx.LifecycleAnnotator.html","title":"PromEx.LifecycleAnnotator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PromEx.LifecycleAnnotator.html#child_spec/1","title":"PromEx.LifecycleAnnotator.child_spec/1","type":"function"},{"doc":"Used to start the PromEx.LifecycleAnnotator process.","ref":"PromEx.LifecycleAnnotator.html#start_link/1","title":"PromEx.LifecycleAnnotator.start_link/1","type":"function"},{"doc":"This GenServer is responsible to keeping track of all the manual metrics from your configured plugins. It will fetch metrics initially when starting (either immediately or after a configured delay). At that point if you would like to refresh your metrics data points call the refresh_metrics/1 function.","ref":"PromEx.ManualMetricsManager.html","title":"PromEx.ManualMetricsManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PromEx.ManualMetricsManager.html#child_spec/1","title":"PromEx.ManualMetricsManager.child_spec/1","type":"function"},{"doc":"This function calls into the GenServer and refreshes all of the configured manual metrics data points.","ref":"PromEx.ManualMetricsManager.html#refresh_metrics/1","title":"PromEx.ManualMetricsManager.refresh_metrics/1","type":"function"},{"doc":"Used to start the PromEx.ManualMetricsManager process","ref":"PromEx.ManualMetricsManager.html#start_link/1","title":"PromEx.ManualMetricsManager.start_link/1","type":"function"},{"doc":"This struct defines the fields necessary to export a group of standard metrics from a plugin.","ref":"PromEx.MetricTypes.Event.html","title":"PromEx.MetricTypes.Event","type":"module"},{"doc":"Create a struct that encompasses a group of event based metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_event_metrics . For example, Phoenix HTTP related metrics have a group_name of: :phoenix_http_event_metrics","ref":"PromEx.MetricTypes.Event.html#build/2","title":"PromEx.MetricTypes.Event.build/2","type":"function"},{"doc":"group_name : A unique identifier for the collection of metrics. metrics : A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Event.html#t:t/0","title":"PromEx.MetricTypes.Event.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of manually collected metric sources from a plugin.","ref":"PromEx.MetricTypes.Manual.html","title":"PromEx.MetricTypes.Manual","type":"module"},{"doc":"Create a struct that encompasses a group of manually triggered metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics . For example, Application related info metrics have a group_name of: :application_versions_manual_metrics","ref":"PromEx.MetricTypes.Manual.html#build/3","title":"PromEx.MetricTypes.Manual.build/3","type":"function"},{"doc":"group_name : A unique identifier for the collection of metrics. measurements_mfa : An MFA tuple that defines what function will be executed that will emit Telemetry events. metrics : A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Manual.html#t:t/0","title":"PromEx.MetricTypes.Manual.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of pollable metric sources from a plugin.","ref":"PromEx.MetricTypes.Polling.html","title":"PromEx.MetricTypes.Polling","type":"module"},{"doc":"Create a struct that encompasses a group of polling type metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics . For example, BEAM related memory metrics have a group_name of: :beam_memory_polling_events","ref":"PromEx.MetricTypes.Polling.html#build/4","title":"PromEx.MetricTypes.Polling.build/4","type":"function"},{"doc":"group_name : A unique identifier for the collection of metrics. measurements_mfa : An MFA tuple that defines what function will be executed that will emit Telemetry events. metrics : A list of Telemetry Metrics structs that define the metrics. poll_rate : An integer representing the millisecond between metrics samples.","ref":"PromEx.MetricTypes.Polling.html#t:t/0","title":"PromEx.MetricTypes.Polling.t/0","type":"type"},{"doc":"This plug is used to serve metrics when PromEx is run in a standalone server configuration. This plug supports the following options: :path - The route that should expose the metrics (default is &quot;/metrics&quot;) :prom_ex_module - The PromEx module that this plug will expose","ref":"PromEx.MetricsServer.Plug.html","title":"PromEx.MetricsServer.Plug","type":"module"},{"doc":"Use this plug in your Endpoint file to expose your metrics. The following options are supported by this plug: :prom_ex_module - The PromEx module whose metrics will be published through this particular plug :path - The path through which your metrics can be accessed (default is &quot;/metrics&quot;) If you need to have some sort of access control around your metrics endpoint, I would suggest looking at another library that I maintain called Unplug ( https://hex.pm/packages/unplug). Using Unplug , you can skip over this plug if some sort of requirement is not fulfilled. For example, if you wanted to configure the metrics endpoint to only be accessible if the request has an Authorization header that matches a configured environment variable you could do something like so using Unplug : defmodule MyApp.UnplugPredicates.SecureMetricsEndpoint do @behaviour Unplug.Predicate @impl true def call ( conn , env_var ) do auth_header = Plug.Conn . get_req_header ( conn , &quot;authorization&quot; ) System . get_env ( env_var ) == auth_header end end Which can then be used in your endpoint.ex file like so: plug Unplug , if : { MyApp.UnplugPredicates.SecureMetricsEndpoint , &quot;PROMETHEUS_AUTH_SECRET&quot; } , do : { PromEx.Plug , prom_ex_module : MyApp.PromEx } The reason that this functionality is not part of PromEx itself is that how you chose to configure the visibility of the metrics route is entirely up to the user and so it felt as though this plug would be over complicated by having to support application config, environment variables, etc. And given that Unplug exists for this purpose, it is the recommended tool for the job.","ref":"PromEx.Plug.html","title":"PromEx.Plug","type":"module"},{"doc":"This module defines the behaviour that PromEx plugins need to implement in order to be properly loaded by PromEx on application start. As a convenience, this module can also be used as a macro to automatically import all of the necessary utility functions for writing plugins and also providing default implementations of behaviour functions that you may not be implementing.","ref":"PromEx.Plugin.html","title":"PromEx.Plugin","type":"behaviour"},{"doc":"The event_metrics/1 callback returns the configured event based metrics that the plugin exposes. If the plugin does not expose any event style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any event style metrics, there is no action needed on your part. This function is expected to either return a single PromEx.Plugins.Event struct or a list of PromEx.Plugins.Event structs.","ref":"PromEx.Plugin.html#c:event_metrics/1","title":"PromEx.Plugin.event_metrics/1","type":"callback"},{"doc":"The manual_metrics/1 callback returns the configured manual based metrics that the plugin exposes. If the plugin does not expose any manual style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any manual style metrics, there is no action needed on your part. This function is expected to either return a single PromEx.Plugins.Manual struct or a list of PromEx.Plugins.Manual structs.","ref":"PromEx.Plugin.html#c:manual_metrics/1","title":"PromEx.Plugin.manual_metrics/1","type":"callback"},{"doc":"The polling_metrics/1 callback returns the configured polling based metrics that the plugin exposes. If the plugin does not expose any polling style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any polling style metrics, there is no action needed on your part. This function is expected to either return a single PromEx.Plugins.Polling struct or a list of PromEx.Plugins.Polling structs.","ref":"PromEx.Plugin.html#c:polling_metrics/1","title":"PromEx.Plugin.polling_metrics/1","type":"callback"},{"doc":"This plugin captures metrics emitted by Absinthe. Specifically, it captures timings and metrics around execution times, query complexity, and subscription timings. In order to get complexity metrics you'll need to make sure that you have :analyze_complexity enabled in Absinthe.Plug . This plugin can generate a large amount of Prometheus series, so it is suggested that you use the ignored_entrypoints and only_entrypoints (TODO: coming soon) options to prune down the resulting metrics if needed. This plugin supports the following options: ignored_entrypoints : This option is OPTIONAL and is used to filter out Absinthe GraphQL schema entrypoints that you do not want to track metrics for. For example, if you don't want metrics on the :__schema entrypoint (used for GraphQL schema introspection), you would set a value of [:__schema] . This is applicable to queries, mutations, and subscriptions. metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :absinthe] . If this changes you will also want to set absinthe_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default absinthe_metric_prefix is {otp_app}_prom_ex_absinthe . This plugin exposes the following metric groups: :absinthe_execute_event_metrics :absinthe_subscription_event_metrics To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.Absinthe , ignored_entrypoints : [ :__schema ] } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;absinthe.json&quot; } ] end end","ref":"PromEx.Plugins.Absinthe.html","title":"PromEx.Plugins.Absinthe","type":"module"},{"doc":"This plugin captures metrics regarding your application, and its dependencies. Specifically, it captures the versions of your application and the application dependencies and also how many modules each dependency is bringing into the project. This plugin supports the following options: otp_app : This is a REQUIRED option and is the name of you application in snake case (e.g. :my_cool_app). deps : This option is OPTIONAL and defines what dependencies the plugin should track. A value of :all means that PromEx will fetch details on all application dependencies. A list of dependency names like [:phoenix, :ecto, :unplug] means that PromEx will only fetch details regarding those dependencies. git_sha_mfa : This option is OPTIONAL and defines an MFA that will be called in order to fetch the application's Git SHA at the time of deployment. By default, an Application Plugin function will be called and will attempt to read the GIT_SHA environment variable to populate the value. git_author_mfa : This option is OPTIONAL and defines an MFA that will be called in order to fetch the application's last Git commit author at the time of deployment. By default, an Application Plugin function will be called and will attempt to read the GIT_AUTHOR environment variable to populate the value. metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :application] . If this changes you will also want to set application_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default application_metric_prefix is {otp_app}_prom_ex_application . This plugin exposes the following metric groups: :application_versions_manual_metrics To use plugin in your application, add the following to your application supervision tree: def start ( _type , _args ) do children = [ ... { PromEx , plugins : [ { PromEx.Plugins.Application , [ otp_app : :my_cool_app ] } , ... ] , delay_manual_start : :no_delay } ] opts = [ strategy : :one_for_one , name : WebApp.Supervisor ] Supervisor . start_link ( children , opts ) end This plugin exposes manual metrics so be sure to configure the PromEx :delay_manual_start as required.","ref":"PromEx.Plugins.Application.html","title":"PromEx.Plugins.Application","type":"module"},{"doc":"Telemetry metrics for the BEAM. This plugin captures metrics regarding the Erlang Virtual Machine (i.e the BEAM). Specifically, it captures metrics regarding the CPU topology, system limits, VM feature support, scheduler information, memory utilization, distribution traffic, and other internal metrics. This plugin supports the following options: poll_rate : This is option is OPTIONAL and is the rate at which poll metrics are refreshed (default is 5 seconds). metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :beam] . If this changes you will also want to set beam_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default beam_metric_prefix is {otp_app}_prom_ex_beam . This plugin exposes the following metric groups: :beam_memory_polling_metrics :beam_internal_polling_metrics :beam_cpu_topology_manual_metrics :beam_system_limits_manual_metrics :beam_system_info_manual_metrics :beam_scheduler_manual_metrics To use plugin in your application, add the following to your PromEx module: defmodule MyApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... PromEx.Plugins.Beam ] end @impl true def dashboards do [ ... { :prom_ex , &quot;beam.json&quot; } ] end end This plugin exposes manual metrics so be sure to configure the PromEx :delay_manual_start as necessary.","ref":"PromEx.Plugins.Beam.html","title":"PromEx.Plugins.Beam","type":"module"},{"doc":"This plugin captures metrics emitted by Broadway. This plugin supports the following options: placeholder : This is a placeholder This plugin exposes the following metric groups: :broadway_init_event_metrics :broadway_message_event_metrics :broadway_batch_event_metrics To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... PromEx.Plugins.Broadway ] end @impl true def dashboards do [ ... { :prom_ex , &quot;broadway.json&quot; } ] end end","ref":"PromEx.Plugins.Broadway.html","title":"PromEx.Plugins.Broadway","type":"module"},{"doc":"This plugin captures metrics emitted by Ecto. Be sure that your PromEx module is listed before your Repo module in your supervision tree so that the Ecto init events are not missed. If you miss those events the dashboard variable dropdowns for the repo value will be broken. This plugin supports the following options: otp_app : This is an OPTIONAL option and is the name of you application in snake case (e.g. :my_cool_app). By default the otp_app set for the prom_ex module that this plugin is defined in is used. metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :ecto] . If this changes you will also want to set ecto_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default ecto_metric_prefix is {otp_app}_prom_ex_ecto . repos : This is an OPTIONAL option and is a list with the full module name of your Ecto Repos (e.g [MyApp.Repo]). If you do not provide this value, PromEx will attempt to resolve your Repo modules via the :ecto_repos configuration on your OTP app. This plugin exposes the following metric groups: :ecto_init_event_metrics :ecto_query_event_metrics To use plugin in your application, add the following to your PromEx module plugins/0 function: def plugins do [ ... { PromEx.Plugins.Ecto , otp_app : :web_app , repos : [ WebApp.Repo ] } ] end","ref":"PromEx.Plugins.Ecto.html","title":"PromEx.Plugins.Ecto","type":"module"},{"doc":"This plugin captures metrics emitted by Oban. Specifically, it captures metrics from job events, producer events, and also from internal polling jobs to monitor queue sizes This plugin supports the following options: oban_supervisors : This is an OPTIONAL option and it allows you to specify what Oban instances should have their events tracked. By default the only Oban instance that will have its events tracked is the default Oban instance. As a result, by default this option has a value of [Oban] . If you would like to track other named Oban instances, or perhaps your default and only Oban instance has a different name, you can pass in your own list of Oban instances (e.g. [Oban, Oban.PrivateJobs] ). metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :oban] . If this changes you will also want to set oban_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default oban_metric_prefix is {otp_app}_prom_ex_oban . poll_rate : This option is OPTIONAL and is the rate at which poll metrics are refreshed (default is 5 seconds). This plugin exposes the following metric groups: :oban_init_event_metrics :oban_job_event_metrics :oban_producer_event_metrics :oban_circuit_event_metrics :oban_queue_poll_metrics To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.Oban , oban_supervisors : [ Oban , Oban.AnotherSupervisor ] , poll_rate : 10_000 } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;oban.json&quot; } ] end end","ref":"PromEx.Plugins.Oban.html","title":"PromEx.Plugins.Oban","type":"module"},{"doc":"","ref":"PromEx.Plugins.Oban.html#oban_circuit_breaker_event_metrics/2","title":"PromEx.Plugins.Oban.oban_circuit_breaker_event_metrics/2","type":"function"},{"doc":"This plugin captures metrics emitted by Phoenix. Specifically, it captures HTTP request metrics and Phoenix channel metrics. Plugin options This plugin supports the following options: metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :phoenix] . If this changes you will also want to set phoenix_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default phoenix_metric_prefix is {otp_app}_prom_ex_phoenix . Single Endpoint/Router router : This option is REQUIRED and is the full module name of your Phoenix Router (e.g MyAppWeb.Router). endpoint : This is a REQUIRED option and is the full module name of your Phoenix Endpoint (e.g MyAppWeb.Endpoint). event_prefix : This option is OPTIONAL and allows you to set the event prefix for the Telemetry events. This value should align with what you pass to Plug.Telemetry in your endpoint.ex file (see the plug docs for more information https://hexdocs.pm/plug/Plug.Telemetry.html ) This value should align with what you pass to Plug.Telemetry in your endpoint.ex file (see the plug docs for more information https://hexdocs.pm/plug/Plug.Telemetry.html ) additional_routes : This option is OPTIONAL and allows you to specify route path labels for applications routes not defined in your Router module. For example, if you want to track telemetry events for a plug in your endpoint.ex file, you can provide a keyword list with the structure [some-route: ~r(/some-path)] and any time that the route is called and the plug handles the call, the path label for this particular Prometheus metric will be set to some-route . You can pass in either a regular expression or a string to match the incoming request. Example plugin configuration { PromEx.Plugins.Phoenix , endpoint : MyApp.Endpoint , router : MyAppWeb.Public.Router , event_prefix : [ :admin , :endpoint ] } Multiple Endpoints/Router endpoints : This accepts a list of per Phoenix Endpoint options {endpoint_name, endpoint_opts} endpoint_name : This option is REQUIRED and is the full module name of your Phoenix Endpoint (e.g MyAppWeb.Endpoint). endpoint_opts : Per endpoint plugin options: :routers : This option is REQUIRED and lists all of routers modules for the endpoint, the HTTP metrics will be augmented with controller/action/path information from the routers. :event_prefix : This option is OPTIONAL and allows you to set the event prefix for the Telemetry events. This value should align with what you pass to Plug.Telemetry in the corresponding endpoint module (see the plug docs for more information https://hexdocs.pm/plug/Plug.Telemetry.html ) :additional_routes : This option is OPTIONAL and allows you to specify route path labels for applications routes not defined in your Router modules for the corresponding endpoint. Example plugin configuration { PromEx.Plugins.Phoenix , endpoints : [ { MyApp.Endpoint , routers : [ MyAppWeb.Public.Router ] } , { MyApp.Endpoint2 , routers : [ MyAppWeb.Admin.Router ] , event_prefix : [ :admin , :endpoint ] } ] } Metric Groups This plugin exposes the following metric groups: :phoenix_http_event_metrics :phoenix_channel_event_metrics :phoenix_socket_event_metrics :phoenix_endpoint_manual_metrics Usage To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.Phoenix , endpoint : MyApp.Endpoint , router : MyAppWeb.Public.Router } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;phoenix.json&quot; } ] end end When working with multiple Phoenix routers use the endpoints option instead: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.Phoenix , endpoints : [ { MyApp.Endpoint , routers : [ MyAppWeb.Public.Router ] } , { MyApp.Endpoint2 , routers : [ MyAppWeb.Admin.Router ] , event_prefix : [ :admin , :endpoint ] } ] } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;phoenix.json&quot; } ] end end","ref":"PromEx.Plugins.Phoenix.html","title":"PromEx.Plugins.Phoenix","type":"module"},{"doc":"This plugin captures metrics emitted by PhoenixLiveView. Specifically, it captures events related to the mount, handle_event, and handle_params callbacks for live views and live components. This plugin supports the following options: metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :phoenix_live_view] . If this changes you will also want to set phoenix_live_view_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default phoenix_live_view_metric_prefix is {otp_app}_prom_ex_phoenix_live_view . This plugin exposes the following metric groups: :phoenix_live_view_event_metrics :phoenix_live_view_component_event_metrics To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... PromEx.Plugins.PhoenixLiveView ] end @impl true def dashboards do [ ... { :prom_ex , &quot;phoenix_live_view.json&quot; } ] end end","ref":"PromEx.Plugins.PhoenixLiveView.html","title":"PromEx.Plugins.PhoenixLiveView","type":"module"},{"doc":"This plugin captures HTTP request metrics emitted by Plug.Cowboy. This plugin exposes the following metric group: :plug_cowboy_http_event_metrics Plugin options routers : Required This is a list with the full module names of your Routers (e.g MyAppWeb.Router). Phoenix and Plug routers are supported. When the Phoenix dependency is present in your project, a list of Phoenix Routers is expected. Otherwise a list of Plug.Router modules must be provided event_prefix : Optional , allows you to set the event prefix for the Telemetry events. metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :plug_cowboy] . If this changes you will also want to set plug_cowboy_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default plug_cowboy_metric_prefix is {otp_app}_prom_ex_plug_cowboy . To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.PlugCowboy , routers : [ MyApp.Router ] } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;plug_cowboy.json&quot; } ] end end To ignore certain paths, pass a list of routes using the :ignore_routes option defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.PlugCowboy , routers : [ MyApp.Router ] , ignore_routes : [ &quot;/metrics&quot; ] } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;plug_cowboy.json&quot; } ] end end","ref":"PromEx.Plugins.PlugCowboy.html","title":"PromEx.Plugins.PlugCowboy","type":"module"},{"doc":"This plugin captures HTTP request metrics emitted by Plug.Router and Plug.Telemetry . This plugin is heavily inspired on plugin Plug.Cowboy , and exposes the following metric group: :plug_router_http_event_metrics Plugin options routers : Required This is a list with the full module names of your Routers (e.g MyAppWeb.Router). Metrics produced by routers not in this list will be discarded. event_prefix : Required , allows you to set the event prefix defined in your Plug.Telemetry configuration: defmodule WebApp.Router do use Plug.Router plug PromEx.Plug , prom_ex_module : WebApp.PromEx , path : &quot;/metrics&quot; plug Plug.Telemetry , event_prefix : [ :webapp , :router ] ... end With the above configuration, this plugin will subscribe to [:webapp, :router, :stop] telemetry events produced by Plug.Telemetry . These events will be fired before the response is actually sent, therefore this plugin will be able to export response body size metrics, since the Plug.Conn struct in the metadata of the telemetry measurement still contains the response body. However, Plug.Telemetry does not use :telemetry.span/3 , which means the :stop event might not always be fired (eg. if the process handling the request crashes). For this reason, this PromEx plugin also subscribes to [:plug, :router_dispatch, :exception] telemetry events fired by Plug.Router , which are fired within a :telemetry.span/3 call. Unfortunately, we cannot safely rely on [:plug, :router_dispatch, :stop] events produced by Plug.Router since these are fired after the response is sent (as opposed to Plug.Telemetry :stop events). As a consequence, the response body is no longer available in the Plug.Conn struct attached to the telemetry measurement metadata. metric_prefix : This option is OPTIONAL and is used to override the default metric prefix of [otp_app, :prom_ex, :plug_router] . If this changes you will also want to set plug_router_metric_prefix in your dashboard_assigns to the snakecase version of your prefix, the default plug_router_metric_prefix is {otp_app}_prom_ex_plug_router . ignore_routes : This option is OPTIONAL and is used to ignore certain paths. To use plugin in your application, add the following to your PromEx module: defmodule WebApp.PromEx do use PromEx , otp_app : :web_app alias PromEx.Plugins @impl true def plugins do [ ... { Plugins.PlugRouter , event_prefix : [ :webapp , :router ] , metric_prefix : [ :prom_ex , :router ] , routers : [ WebApp.Router ] } ] end @impl true def dashboard_assigns do [ datasource_id : &quot;...&quot; , plug_router_metric_prefix : &quot;prom_ex_router&quot; ] end @impl true def dashboards do [ ... { :prom_ex , &quot;plug_router.json&quot; } ] end end To ignore certain paths, pass a list of routes using the :ignore_routes option defmodule WebApp.PromEx do use PromEx , otp_app : :web_app @impl true def plugins do [ ... { PromEx.Plugins.PlugRouter , event_prefix : [ :webapp , :router ] , metric_prefix : [ :prom_ex , :router ] , routers : [ WebApp.Router ] , ignore_routes : [ &quot;/metrics&quot; ] } ] end @impl true def dashboards do [ ... { :prom_ex , &quot;plug_router.json&quot; } ] end end","ref":"PromEx.Plugins.PlugRouter.html","title":"PromEx.Plugins.PlugRouter","type":"module"},{"doc":"This module prodvides several general purpose utilities for use in PromEx plugs.","ref":"PromEx.Utils.html","title":"PromEx.Utils","type":"module"},{"doc":"Normalize exception messages for use as metric labels.","ref":"PromEx.Utils.html#normalize_exception/3","title":"PromEx.Utils.normalize_exception/3","type":"function"},{"doc":"Take a module name and normalize it for use as a metric label.","ref":"PromEx.Utils.html#normalize_module_name/1","title":"PromEx.Utils.normalize_module_name/1","type":"function"},{"doc":"The kinds of exceptions that can occur","ref":"PromEx.Utils.html#t:exception_kind/0","title":"PromEx.Utils.exception_kind/0","type":"type"},{"doc":"Prometheus metrics and Grafana dashboards for all of your favorite Elixir libraries Contents Installation Supporting PromEx Setting Up PromEx Adding Your Metrics Design Philosophy Available Plugins Grafana Dashboards Security Concerns Performance Concerns Attribution","ref":"readme.html","title":"README","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding prom_ex to your list of dependencies in mix.exs : def deps do [ { :prom_ex , &quot;~&gt; 1.6.0&quot; } ] end Documentation can be found at https://hexdocs.pm/prom_ex .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"PromEx has an ambition goal: To provide Prometheus metrics and Grafana dashboards for as many of the libraries in the Elixir ecosystem as possible as well as a framework so that you can manage the lifecycle of your own metrics and dashboards. If you rely on PromEx to monitor your production applications, it would much appreciated if you can give back to the project in order to help ensure its continued development. Gold Sponsors Silver Sponsors Bronze Sponsors","ref":"readme.html#supporting-promex","title":"README - Supporting PromEx","type":"extras"},{"doc":"The goal of PromEx is to have metrics set up be as simple and streamlined as possible. In that spirit, all that you need to do to start leveraging PromEx along with the built-in plugins is to run the following mix task (the YOUR_PROMETHEUS_DATASOURCE_ID value should align with what is configured in Grafana as the name of the Prometheus data source): $ mix prom_ex.gen.config --datasource YOUR_PROMETHEUS_DATASOURCE_ID Then add the generated module to your application.ex file supervision tree (be sure to add it to the top of the supervisor children list so that you do not miss any init-style events from other processes like Ecto.Repo for example): defmodule MyCoolApp.Application do use Application def start ( _type , _args ) do children = [ MyCoolApp.PromEx , ... ] opts = [ strategy : :one_for_one , name : MyCoolApp.Supervisor ] Supervisor . start_link ( children , opts ) end end With that in place, all that you need to do is then add the PromEx plug somewhere in your endpoint.ex file (I would suggest putting it before your plug Plug.Telemetry call so that you do not pollute your logs with calls to /metrics ): defmodule MyCoolAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :my_cool_app ... plug PromEx.Plug , prom_ex_module : MyCoolApp.PromEx # Or plug PromEx.plug, path: &quot;/some/other/metrics/path&quot;, prom_ex_module: MyCoolApp.PromEx ... plug Plug.RequestId plug Plug.Telemetry , event_prefix : [ :phoenix , :endpoint ] ... plug MyCoolAppWeb.Router end With that in place, all you need to do is start your server and you should be able to hit your metrics endpoint and see your application metrics: $ curl localhost:4000/metrics # HELP my_cool_app_application_dependency_info Information regarding the application's dependencies. # TYPE my_cool_app_application_dependency_info gauge my_cool_app_application_dependency_info{modules=&quot;69&quot;,name=&quot;hex&quot;,version=&quot;0.20.5&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;1&quot;,name=&quot;connection&quot;,version=&quot;1.0.4&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;4&quot;,name=&quot;telemetry_poller&quot;,version=&quot;0.5.1&quot;} 1 ... Be sure to check out the module docs for each plugin that you choose to use to ensure that you are familiar with all of the options that they provide.","ref":"readme.html#setting-up-promex","title":"README - Setting Up PromEx","type":"extras"},{"doc":"While PromEx provides plugins for a lot of the popular community libraries, you can also leverage it to collect metrics specific to your application. Similarly to how you use the PromEx Ecto plugin to collect metrics relevant to Ecto, you can write your own plugin to collect metrics specific to your application. In fact, the same tools that PromEx uses for its plugins are what you should use to create your own application specific plugins. To write your own PromEx plugin, create a module that implements the PromEx.Plugin behaviour and collect the relevant event/polling/manual metrics. Be sure to check out the 1st party PromEx plugins as a reference for how plugins are written and how to collect the different types of data points (also checkout the Writing PromEx Plugins guide). As a side note, PromEx will attach its own Telemetry handlers to events in order to capture Prometheus compatible metrics and so any data points that are added to your telemetry.ex file (if you are using LiveDashboard) will not show up in PromEx. One of the benefits of the Telemetry library is that you can have an arbitrary number of event handlers attached to Telemetry events and so LiveDashboard and PromEx can operate in the same application without any issues.","ref":"readme.html#adding-your-metrics","title":"README - Adding Your Metrics","type":"extras"},{"doc":"With the widespread adoption of the Telemetry library and the other libraries in the BEAM Telemetry GitHub Org , we have reached a point in the Elixir ecosystem where we have a consistent means of surfacing application and library metrics. This allows us to have a great level of insight into our applications and dependencies given that they all leverage the same fundamental tooling. The goal of this project is to provide a &quot;Plug-in&quot; style library where you can easily add new plug-ins to surface metrics so that Prometheus can scrape them. Ideally, this project acts as the &quot;Metrics&quot; pillar in your application (in reference to The Three Pillars of Observability ). To this end, while PromEx does provide a certain level of configurability (like the polling rate, starting behaviour for manual metrics and all the options that the plugins receive), the goal is not to make an infinitely configurable tool. For example, you are not able to edit the names/descriptions of Prometheus metrics via plugin options or even the tags that are attached to the data points. Instead, if there things that you don't agree with or that are incompatible with your usage of a certain 1st party plugin and want to edit how the PromEx plugins react to Telemetry events, it is recommended that you fork the plugin in question and edit it to your specific use case. If you think that the community can benefit for your changes, do not hesitate to make a PR and I'll be sure to review it. This is not to say that event configurability will never come to PromEx, but I want to make sure that the public facing API is clean and straightforward and not bogged down with too much configuration. In addition, the Grafana dashboards would then have to have a lot of templatized logic to accommodate all this configurability (something which has been a pain-point in the Helm community for example). PromEx provides the following utilities to you in order to achieve your observability goals: The PromEx.Plug module that can be used in your Phoenix or Plug application to expose the collected metrics A standalone HTTP metrics server if Phoenix is not a dependency in your project A Mix task to upload the provided complimentary Grafana dashboards A Mix task to create a PromEx metrics capture module A behaviour that defines the contract for PromEx plug-ins A behaviour that defines the functionality of a PromEx metrics capture module Grafana dashboards tailored to each specific Plugin so that metrics work out of the box with dashboards Grafana API support to create/upload to dashboard folders and to create graph annotations to mark events in Grafana EEx Grafana dashboard templates so you can dynamically tweak dashboards prior to uploading","ref":"readme.html#design-philosophy","title":"README - Design Philosophy","type":"extras"},{"doc":"Plugin Status Description PromEx.Plugins.Application Stable Collect metrics on your application dependencies PromEx.Plugins.Beam Stable Collect metrics regarding the BEAM virtual machine PromEx.Plugins.Phoenix Stable Collect request metrics emitted by Phoenix PromEx.Plugins.Ecto Stable Collect query metrics emitted by Ecto PromEx.Plugins.Oban Stable Collect queue processing metrics emitted by Oban PromEx.Plugins.PhoenixLiveView Stable Collect metrics emitted by Phoenix LiveView PromEx.Plugins.Absinthe Beta Collect GraphQL metrics emitted by Absinthe PromEx.Plugins.PlugCowboy Beta Collect HTTP request metrics emitted by Plug.Cowboy PromEx.Plugins.PlugRouter Beta Collect HTTP request metrics emitted by Plug.Router and Plug.Telemetry PromEx.Plugins.Broadway Coming soon Collect message processing metrics emitted by Broadway PromEx.Plugins.Finch Coming soon Collect HTTP request metrics emitted by Finch PromEx.Plugins.Redix Coming soon Collect Redis request metrics emitted by Redix More to come...","ref":"readme.html#available-plugins","title":"README - Available Plugins","type":"extras"},{"doc":"Each PromEx plugin comes with a custom tailored Grafana Dashboard. Click here to check out sample screenshots of each Plugin specific Grafana Dashboard.","ref":"readme.html#grafana-dashboards","title":"README - Grafana Dashboards","type":"extras"},{"doc":"By default, you can set up a Prometheus scrape target without providing any security authorization configuration. As a result, PromEx does not enforce any security precautions by default, and it is up to you to secure your /metrics endpoint to ensure that people are not seeing sensitive information (sort of like Phoenix LiveDashboard where you need to set up your own basic authentication plug to guard access). There are a couple of solutions to this problem: If your application is behind a load balancer or an API gateway, you can block access for any external requests to /metrics (or whatever route you chose to expose metrics over). If your application is public facing, you can leverage the Unplug library that I maintain in order to only execute the PromEx.Plug plug when the incoming request fulfills your configured requirements (see the PromEx.Plug HexDocs for an example).","ref":"readme.html#security-concerns","title":"README - Security Concerns","type":"extras"},{"doc":"You may think to yourself that with all these metrics being collected and scraped, that the performance of your application may be negatively impacted. Luckily PromEx is built upon the solid foundation established by the Telemetry , TelemetryMetrics , and the TelemetryMetricsPrometheus projects. These libraries were designed to be as lightweight and performant as possible. From some basic stress tests that I have run, I have been unable to observe any meaningful performance reduction (thank you OTP and particularly ETS ;)). Below are the results from a recent stress test using ApacheBench: With PromEx metrics collection $ ./benchmarks/ab-graph.sh -u http://localhost:4000 -n 1000 -c 50 -k Server Software: Cowboy Server Hostname: localhost Server Port: 4000 Document Path: / Document Length: 3389 bytes Concurrency Level: 50 Time taken for tests: 4.144 seconds Complete requests: 1000 Failed requests: 0 Keep-Alive requests: 1000 Total transferred: 4060000 bytes HTML transferred: 3389000 bytes Requests per second: 241.32 [#/sec] (mean) Time per request: 207.191 [ms] (mean) Time per request: 4.144 [ms] (mean, across all concurrent requests) Transfer rate: 956.81 [Kbytes/sec] received Connection Times (ms) min mean[+/-sd] median max Connect: 0 0 0.2 0 1 Processing: 39 202 24.3 203 264 Waiting: 38 202 24.3 203 264 Total: 39 202 24.2 203 264 Percentage of the requests served within a certain time (ms) 50% 203 66% 210 75% 215 80% 218 90% 227 95% 237 98% 246 99% 255 100% 264 (longest request) Without PromEx metrics collection $ ./benchmarks/ab-graph.sh -u http://localhost:4000 -n 1000 -c 50 -k Server Software: Cowboy Server Hostname: localhost Server Port: 4000 Document Path: / Document Length: 3389 bytes Concurrency Level: 50 Time taken for tests: 4.156 seconds Complete requests: 1000 Failed requests: 0 Keep-Alive requests: 1000 Total transferred: 4060000 bytes HTML transferred: 3389000 bytes Requests per second: 240.59 [#/sec] (mean) Time per request: 207.822 [ms] (mean) Time per request: 4.156 [ms] (mean, across all concurrent requests) Transfer rate: 953.90 [Kbytes/sec] received Connection Times (ms) min mean[+/-sd] median max Connect: 0 0 0.1 0 1 Processing: 38 202 23.1 205 267 Waiting: 37 202 23.1 205 267 Total: 38 202 23.0 205 267 Percentage of the requests served within a certain time (ms) 50% 205 66% 211 75% 215 80% 219 90% 226 95% 232 98% 238 99% 246 100% 267 (longest request) Plotting the stress test results In the spirit of visualizing performance characteristics, the percentile data from the ApacheBench stress tests has been overlaid and plotted using Gnuplot (thanks to apachebench-graphs for making Gnuplot-ing a lot more streamlined :)). As we can see, the distributions track each other more or less 1:1 except for the slowest 5-10% of requests where we see a slight performance hit. In other words, 90% of the time there was no measurable performance overhead in the instrumented application.","ref":"readme.html#performance-concerns","title":"README - Performance Concerns","type":"extras"},{"doc":"It wouldn't be right to not include somewhere in this project a &quot;thank you&quot; to the various projects and people that helped make this possible: The various projects available in BEAM Telemetry All of the Prometheus libraries that Ilya Khaprov ( @deadtrickster ) maintains The logo for the project is an edited version of an SVG image from the unDraw project Juan Luis Baptiste for the nifty ApacheBench+Gnuplot shell scripts apachebench-graphs","ref":"readme.html#attribution","title":"README - Attribution","type":"extras"},{"doc":"This guide will walk you through writing a PromEx plugin. Whether this plugin is for a dependent library or for your internal application metrics, the same patterns apply.","ref":"writing-promex-plugins.html","title":"Writing PromEx Plugins","type":"extras"},{"doc":"In order for PromEx to be able to load the appropriate metrics from your plugins, your modules need to leverage the PromEx behaviour. This behaviour defines 3 optional callbacks. Those callbacks are: event_metrics/1 polling_metrics/1 manual_metrics/1 Each of these callbacks is supposed to return a list of metrics of that type. For example, polling_metrics/1 needs to return a list of PromEx.MetricTypes.Polling structs (a single struct is also an acceptable return). By doing this, you plugin can load your metrics and deal with the nuances of each metric type properly. Each of the MetricTypes structs all have a field called :metrics . This field contains a list of all the Telemetry.Metrics definitions that were provided to the struct build function.","ref":"writing-promex-plugins.html#getting-started","title":"Writing PromEx Plugins - Getting started","type":"extras"},{"doc":"To have your custom plugin expose event based metrics, implement a event_metrics/1 function and build our a collection of Telemetry.Metrics structs ( distribution , counter , last_value , and sum ). Be sure to look at plugins like PromEx.Plugins.Phoenix for more in depth examples. defmodule MyApp.PromEx.Plugins.MyPhoenix do use PromEx.Plugin @impl true def event_metrics ( opts ) do http_metrics_tags = gen_http_metrics_tags ( opts ) phoenix_router = get_phoenix_router ( opts ) phoenix_stop_event = [ :phoenix , :endpoint , :stop ] Event . build ( :phoenix_http_event_metrics , [ # Capture request duration information distribution ( [ :phoenix , :http , :request , :duration , :milliseconds ] , event_name : phoenix_stop_event , measurement : :duration , description : &quot;The time it takes for the application to respond to HTTP requests.&quot; , reporter_options : [ buckets : exponential ( 1 , 2 , 12 ) ] , tag_values : get_conn_tags ( phoenix_router ) , tags : http_metrics_tags , unit : { :native , :millisecond } ) # Additional event based metrics ... ] ) end end","ref":"writing-promex-plugins.html#adding-event-metrics","title":"Writing PromEx Plugins - Adding Event Metrics","type":"extras"},{"doc":"Polling metrics are similar to event metrics in that they require similar fields ( group_name and metrics to be specific). In addition, the PromEx.MetricTypes.Polling.build/4 function requires an measurements_mfa argument which specifies what function will be executed on the polling interval. This function should run :telemetry.execute/3 somewhere in its function body. Once that event is executed, the corresponding event in the struct will be triggered and you will capture the desired data point. The following example from PromEx.Plugins.Beam should highlight this concept: defmodule PromEx.Plugins.Beam do use PromEx.Plugin @memory_event [ :prom_ex , :plugin , :beam , :memory ] @impl true def polling_metrics ( opts ) do poll_rate = Keyword . get ( opts , :poll_rate , 5_000 ) [ memory_metrics ( poll_rate ) ] end defp memory_metrics ( poll_rate ) do Polling . build ( :beam_memory_polling_events , poll_rate , { __MODULE__ , :execute_memory_metrics , [ ] } , [ # Capture the total memory allocated to the entire Erlang VM (or BEAM for short) last_value ( [ :beam , :memory , :total , :kilobytes ] , event_name : @memory_event , description : &quot;The total amount of memory currently allocated.&quot; , measurement : :total , unit : { :byte , :kilobyte } ) # More memory metrics here ] ) end @doc false def execute_memory_metrics do memory_measurements = :erlang . memory ( ) |&gt; Map . new ( ) :telemetry . execute ( @memory_event , memory_measurements , %{ } ) end end Depending on what :poll_rate value you pass to the initialization tuple for PromEx.Plugins.Beam , the execute_memory_metrics/0 function will be execute on that specified interval.","ref":"writing-promex-plugins.html#adding-polling-metrics","title":"Writing PromEx Plugins - Adding Polling Metrics","type":"extras"},{"doc":"Manual metrics behave more or less the same as polling metrics except they do not require a poll rate value. Instead the provided measurements_mfa is called once on application start, and the metrics are only then updated if you make a call to PromEx.ManualMetricsManager.refresh_metrics/1 . An example of this can be seen from the PromEx.Plugins.Application plugin: defmodule PromEx.Plugins.Application do use PromEx.Plugin @impl true def manual_metrics ( opts ) do otp_app = Keyword . fetch! ( opts , :otp_app ) apps = Keyword . get ( opts , :deps , :all ) Manual . build ( :application_versions_manual_metrics , { __MODULE__ , :apps_running , [ otp_app , apps ] } , [ # Capture information regarding the primary application (i.e the user&#39;s application) last_value ( [ otp_app | [ :application , :primary , :info ] ] , event_name : [ otp_app | [ :application , :primary , :info ] ] , description : &quot;Information regarding the primary application.&quot; , measurement : :status , tags : [ :name , :version , :modules ] ) # Additional metrics here ] ) end @doc false def apps_running ( otp_app , apps ) do ... # Emit primary app details :telemetry . execute ( [ otp_app | [ :application , :primary , :info ] ] , %{ status : if ( Map . has_key? ( started_apps , otp_app ) , do : 1 , else : 0 ) } , %{ name : otp_app , version : Map . get_lazy ( started_apps , otp_app , fn -&gt; Map . get ( loaded_only_apps , otp_app , &quot;undefined&quot; ) end ) , modules : length ( Application . spec ( otp_app ) [ :modules ] ) } ) end end So in this example, apps_running/2 is the function that is denoted by the MFA and will be called once automatically on application start, but then at that point it is up to the user to refresh the data point.","ref":"writing-promex-plugins.html#adding-manual-metrics","title":"Writing PromEx Plugins - Adding Manual Metrics","type":"extras"},{"doc":"This section serves as a quick primer for the Telemetry library, how it works, and how you can leverage it in your applications. While there is nothing specific to PromEx here, but it is important to know how Telemetry works so that you can effectively create your own PromEx plugins.","ref":"telemetry.html","title":"Introduction to Telemetry","type":"extras"},{"doc":"At a high level, Telemetry offers a means for libraries and applications to surface internal events. These events can be emitted prior to starting some logical body of work, after the work has completed, after the processing of the work has resulted in an exception, or even any time you want to denote that something of importance has occurred. As an example, these events can include the time it takes to process incoming HTTP requests (like in Phoenix) or the time it takes to process a job (like in Broadway &amp; Oban) and well as metadata related to the event (like the requested route in Phoenix).","ref":"telemetry.html#what-is-telemetry","title":"Introduction to Telemetry - What is Telemetry?","type":"extras"},{"doc":"Under the hood, Telemetry works by attaching callback functions to events (tracked in ETS), and then invoking those functions serially whenever that event occurs. In other words, any time an event is triggered, Telemetry dynamically dispatches to each of the callbacks that are registered for that particular event. You can think of this as effectively being a pub/sub style library but synchronous as opposed to asynchronous. Given that the callbacks are executed in a synchronous fashion, it is highly recommended that you keep your callbacks very lightweight and functionally limited. If additional blocking work needs to take place as a result of an event, be sure to spin that work off into its own Task or pass it along to a separate GenServer.","ref":"telemetry.html#how-does-it-work","title":"Introduction to Telemetry - How Does it Work?","type":"extras"},{"doc":"In my opinion, Telemetry (and the other repositories in the beam-telemetry GitHub organization) provides two key benefits to the Erlang, Elixir and Beam communities. Firstly, Telemetry provides a consistent interface through which applications and libraries can expose internal events. This consistent interface consists of measurements and metadata that are attached to each event that can then be used by consumers in whichever way fits the user's needs. For example, using the same Telemetry event, you can produce a custom log message and even metrics by attaching two separate callback functions to the desired Telemetry event. Secondly, attaching callbacks to Telemetry events is a very low friction operation and can be done without much ceremony. This is important given that if the ergonomics of Telemetry were cumbersome to work with, library authors would not be inclined to leverage Telemetry for surfacing internal events. Specifically, Telemetry does not require any global setup or configuration by either the library author or the user. Instead, Telemetry will sort out the dynamic function dispatch through ETS tables that it manages and will only invoke callback functions when callbacks have been attached to a particular event. As a result of these two points (and others), it is no surprise that over 100 libraries in the Elixir and Erlang ecosystem have adopted Telemetry as their primary means of surfacing internal events.","ref":"telemetry.html#why-is-telemetry-important","title":"Introduction to Telemetry - Why is Telemetry Important?","type":"extras"},{"doc":"As previously mentioned, leveraging Telemetry consists of a library (or your application) executing an event, and you as the user attaching a callback to said event. As an example, let's suppose that we want to emit an event any time a user registers for our service. In our registration function we could do something like so in order to capture when users are successfully created and when errors are encountered: def register_user ( attrs ) do % User { } |&gt; User . registration_changeset ( updated_attrs ) |&gt; Repo . insert ( ) |&gt; case do { :ok , new_user } = result -&gt; :telemetry . execute ( [ :my_cool_app , :accounts , :new_user , :success ] , %{ } , %{ user : new_user } ) result { :error , changeset } = error -&gt; :telemetry . execute ( [ :my_cool_app , :accounts , :new_user , :error ] , %{ } , %{ error : changeset } ) error end end Elsewhere in your application code (perhaps where you initialize your application) you can attach to these events by doing the following: :telemetry . attach ( [ :my_cool_app , :accounts , :new_user , :success ] , query_event , fn _event_name , _event_measurement , event_metadata , _config -&gt; Logger . debug ( &quot;User has registered: \#{ inspect ( event_metadata ) } &quot; ) end , %{ } ) :telemetry . attach ( [ :my_cool_app , :accounts , :new_user , :error ] , query_event , fn _event_name , _event_measurement , event_metadata , _config -&gt; Logger . warn ( &quot;User failed to register: \#{ inspect ( event_metadata ) } &quot; ) end , %{ } ) Now, any time an error occurs and a user fails to register a warning log is generated with the metadata related to the error. Similarly, a debug log message is created any time a user is successfully created.","ref":"telemetry.html#how-can-i-use-telemetry-in-my-project","title":"Introduction to Telemetry - How Can I Use Telemetry in my Project?","type":"extras"},{"doc":"https://github.com/beam-telemetry/telemetry https://hexdocs.pm/telemetry_metrics/Telemetry.Metrics.html https://keathley.io/blog/telemetry-conventions.html","ref":"telemetry.html#additional-resources","title":"Introduction to Telemetry - Additional Resources","type":"extras"},{"doc":"","ref":"all.html","title":"Dashboards Screenshots","type":"extras"},{"doc":"The application dashboard surfaces static information regarding the application. Things such as the dependencies of the application, GIT SHA+author and uptime.","ref":"all.html#application","title":"Dashboards Screenshots - Application","type":"extras"},{"doc":"The BEAM dashboard presents information regarding the Erlang virtual machine. Things such as memory statistics, process and atom counts, scheduler information, and much more","ref":"all.html#beam","title":"Dashboards Screenshots - BEAM","type":"extras"},{"doc":"The Ecto dashboard contains charts to track query execution time, number of results returned, and static information regarding the configured Repo.","ref":"all.html#ecto","title":"Dashboards Screenshots - Ecto","type":"extras"},{"doc":"The Oban plugin presents information regarding the job execution time, job queue time, available jobs in queue, static configuration settings and much, much more.","ref":"all.html#oban","title":"Dashboards Screenshots - Oban","type":"extras"},{"doc":"The Phoenix dashboard presents information regarding HTTP requests and channel connections.","ref":"all.html#phoenix","title":"Dashboards Screenshots - Phoenix","type":"extras"},{"doc":"The Phoenix LiveView dashboard presents information regarding the various LiveView callbacks and the time it takes to execute them.","ref":"all.html#phoenix-liveview","title":"Dashboards Screenshots - Phoenix LiveView","type":"extras"}]